/*
 *
 *
 *    Resea (api/interrupt.c)
 *    Mafice <mafice@mflabo.net>
 *
 *
 */

#include <stdbool.h>
#include <Resea/types.h>
#include <Resea/abi.h>



/*
*  Function: waitInterrupt
*
*    割り込みを待つ
*
*  Parameters:
*
*    なし
*
*  Returns:
*
*    なし
*
*/

void waitInterrupt (void){


  asm_waitInterrupt();

  return;
}





/*
*  Function: setISR
*
*    割り込みハンドラを登録する
*
*  Parameters:
*
*    irq    -  割り込み要求の番号
*    offset -  ハンドラの先頭アドレス
*
*  Returns:
*
*    登録に成功した場合はtrue、失敗した場合はfalseを返します。
*
*/

bool setISR (IRQ_t irq, offset_t offset){


  return asm_setISR(irq, offset);
}

