//
//
//
//    Resea (/kernel/net/sys/sys.c)
//    Mafice <mafice@mflabo.net>
//
//
//

#include "kernel.h"
#include "net.h"

void asm_intNE2000Handler (void);
void NE2000_init (u8 *MACAddress);
void NE2000_send (void *frame, u32 size);


struct NetInfo Net;



/*
*  Function: initNetwork
*
*    ネットワーク機能を初期化する
*
*  Parameters:
*
*    なし
*
*  Returns:
*
*    なし
*
*/

void initNetwork (void){


  Net.IPAddr    = 0;
  Net.gotIPAddr = false;


  // NICドライバを初期化し、ついでにMACアドレスを取得
  NE2000_init((u8 *) &Net.MACAddr);


  // ブロードキャストアドレス
  Net.ARP.Cache[0].IPAddr     = 0xffffffff;
  Net.ARP.Cache[0].MACAddr[0] = 0xff;
  Net.ARP.Cache[0].MACAddr[1] = 0xff;
  Net.ARP.Cache[0].MACAddr[2] = 0xff;
  Net.ARP.Cache[0].MACAddr[3] = 0xff;
  Net.ARP.Cache[0].MACAddr[4] = 0xff;
  Net.ARP.Cache[0].MACAddr[5] = 0xff;

  //FIXME
 index_t ct;

  ct = createTCPConnection(0, 0, 80);
  Net.TCP.Connection[ct].status = TCP_CONT_CLOSED;

  // IPアドレスを取得
  getIPAddrByDHCP();


  // IPアドレスの取得を待つ
  asm_sti();
  while(!Net.gotIPAddr);
  asm_cli();

  print("\nWelcome to Resea Web Server!\n");
  print("Please try to access localhost:12345.\n");

  asm_sti();
  for(;;) asm_hlt();
}




/*
*  Function: sendPacket
*
*    フレームを送信する
*
*  Parameters:
*
*    frame -  フレーム
*    size  -  サイズ
*
*  Returns:
*
*    なし
*
*/

void sendPacket (void *frame, u32 size){

  NE2000_send(frame, size);
  return;
}

